
      .586                   ; minimum processor needed for 32 bit
      .model flat, stdcall   ; FLAT memory model  STDCALL calling
      option casemap :none   ; set code to case sensitive


	include mySQL.inc    
		
    .code
  
          
start:

		invoke GetModuleHandle, NULL ; provides the instance handle
		mov hInstance, eax

		invoke GetCommandLine        ; provides the command line address
		mov CommandLine, eax

		invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT

		invoke ExitProcess,eax       ; cleanup  return to operating system


;===========================================================================================
 


WinMain Proc hInst     :DWORD,  hPrevInst :DWORD, CmdLine   :DWORD,  CmdShow   :DWORD

        ;====================
        ; Put LOCALs on stack
        ;====================

        LOCAL wc   :WNDCLASSEX
        LOCAL msg  :MSG 

        LOCAL Wwd  :DWORD
        LOCAL Wht  :DWORD
        LOCAL Wtx  :DWORD
        LOCAL Wty  :DWORD

  

        ;==================================================
        ; Fill WNDCLASSEX structure with required variables
        ;==================================================

        mov wc.cbSize,         sizeof WNDCLASSEX
        mov wc.style,          CS_HREDRAW or CS_VREDRAW  or CS_BYTEALIGNWINDOW
        mov wc.lpfnWndProc,    offset WndProc      ; address of WndProc
        mov wc.cbClsExtra,     NULL
        mov wc.cbWndExtra,     NULL
        m2m wc.hInstance,      hInst               ; instance handle
        mov wc.hbrBackground,  COLOR_BTNFACE+1     ; system color
        mov wc.lpszMenuName,   NULL
        mov wc.lpszClassName,  offset szClassName  ; window class name
        invoke LoadIcon,hInst,500    ; icon ID   ; resource icon
        mov wc.hIcon,          eax
        invoke LoadCursor,NULL,IDC_ARROW         ; system cursor
        mov wc.hCursor,        eax
        mov wc.hIconSm,        0

        invoke RegisterClassEx, ADDR wc     ; register the window class


   
        ;================================     
        ; Centre window at following size
        ;================================

        mov Wwd, 600
        mov Wht, 400

        invoke GetSystemMetrics,SM_CXSCREEN ; get screen width in pixels
        invoke TopXY,Wwd,eax
        mov Wtx, eax

        invoke GetSystemMetrics,SM_CYSCREEN ; get screen height in pixels
        invoke TopXY,Wht,eax
        mov Wty, eax

        ; ==================================
        ; Create the main application window    
        ;===================================
         invoke CreateWindowEx,NULL,ADDR szClassName,ADDR szDisplayName,WS_OVERLAPPEDWINDOW,
         Wtx,Wty,Wwd,Wht,NULL,NULL,hInst,NULL 

		mov   hwnd,eax  ; copy return value into handle DWORD

 
        invoke LoadMenu,hInst,600					; load resource menu
		mov hMenu,eax
        invoke SetMenu,hwnd,hMenu                   ; set it to main window

        invoke ShowWindow,hwnd,SW_SHOWNORMAL		; display the window
     
		invoke UpdateWindow,hwnd					; update the display

      ;===================================
      ; Loop until PostQuitMessage is sent
      ;===================================


    StartLoop:
      invoke GetMessage,ADDR msg,NULL,0,0         ; get each message
      cmp eax, 0                                  ; exit if GetMessage()
      je ExitLoop                                 ; returns zero
      invoke TranslateMessage, ADDR msg           ; translate it
      invoke DispatchMessage,  ADDR msg           ; send it to message proc
      jmp StartLoop
    ExitLoop:

      return msg.wParam

WinMain Endp  

;===========================================================================================
 
WndProc Proc uses edi esi hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

 
  

    .if uMsg == WM_CREATE
    
		;==============================
		; Create Listview and Statusbar
		;==============================

		invoke CreateWindowEx, WS_EX_CLIENTEDGE, addr ListViewClassName, NULL,LVS_REPORT+WS_CHILD+WS_VISIBLE, 0,0,0,0,hWnd, NULL,	hInstance, NULL
		mov hList, eax		

		mov eax, LVS_EX_FULLROWSELECT  or  LVS_EX_GRIDLINES

		invoke SendMessage, hList, LVM_SETEXTENDEDLISTVIEWSTYLE, 0, eax

		invoke SendMessage,hList,LVM_DELETEALLITEMS,0,0	

		invoke SendMessage,hList, LVM_DELETECOLUMN,0,addr lvc

		invoke InsertColumn,hList   

		RGB 0,0,0
		invoke SendMessage,hList,LVM_SETTEXTCOLOR,0,eax			; textcolor
		RGB 255,255,255 
		invoke SendMessage,hList,LVM_SETBKCOLOR,0,eax			; background color
		RGB 255,255,255  
		invoke SendMessage,hList,LVM_SETTEXTBKCOLOR,0,eax		; text background color


		invoke Do_Status,hWnd		; create statusbar 
       
 
    .elseif uMsg == WM_COMMAND
   		   
		mov eax, wParam
		shr eax, 16
 
			 .if wParam == IDM_QUERY 
			 
					invoke mysql_select_db,offset myData,addr wincc_db	;Causes the database specified  to become the default (current) database
					
					.if eax == 0

    					invoke FillDataProc
	    			
    				.else
	    			   			
						invoke mysql_error,offset myData
						invoke MessageBox,0,eax,addr mysqlerror,0
						
    				.endif
    				 
    			

			
			.elseif wParam == IDM_INSERT_DATA
			
				invoke mysql_query,offset myData,addr DBInsert 
				.if eax != 0
						
					invoke mysql_error,offset myData
					invoke MessageBox,0,eax,addr mysqlerror,0
					
				.endif	
				
			.elseif wParam == IDM_CONNECT
			
			invoke mysql_init,0  
			mov dword ptr myData,eax  ;Allocates or initializes a MYSQL object suitable for mysql_real_connect()

		
			.if eax != NULL
			
				invoke mysql_real_connect, offset myData ,addr host,addr sqluser,NULL,addr database,3306,NULL,0		;mysql_real_connect() attempts to establish a connection to a MySQL database engine 
				
				.if eax != NULL
				
					invoke LoadImage,hInstance,500 ,IMAGE_ICON, 16,16,0  
					invoke SendMessage,hStatusBar,SB_SETICON,0,eax 
					invoke SendMessage,hStatusBar,SB_SETTEXT,0, addr Connected
					invoke mysql_select_db,offset myData,addr wincc_db	;Causes the database specified  to become the default (current) database
					.if eax == 0		; SUccess , database exists
				
						invoke EnableMenuItem, hMenu, IDM_DELETE, MF_ENABLED
						invoke EnableMenuItem, hMenu, IDM_QUERY, MF_ENABLED
						invoke EnableMenuItem, hMenu, IDM_INSERT_DATA, MF_ENABLED
				
					.else
				
						invoke EnableMenuItem, hMenu, IDM_CREATE, MF_ENABLED
						invoke EnableMenuItem, hMenu, IDM_DELETE, MF_GRAYED
						
	
					.endif

					invoke EnableMenuItem, hMenu, IDM_DISCONNECT, MF_ENABLED

				.else
				
					invoke mysql_error,offset myData
					invoke MessageBox,0,eax,addr mysqlerror,0
 
				.endif
				
			.else
				invoke mysql_error,offset myData
				invoke MessageBox,0,eax,addr mysqlerror,0

			.endif			
			
				invoke EnableMenuItem, hMenu, IDM_CONNECT, MF_GRAYED
	
			.elseif wParam == IDM_CREATE
			
				invoke mysql_query,  offset myData ,addr createdb		; Create a new database
						
				.if eax == 0		;  0 = success
					
						invoke mysql_select_db,offset myData,addr wincc_db 	;Causes the database specified  to become the default (current) database 
						.if eax == 0 

							invoke mysql_query,  offset myData ,addr grant  ; Set user privileges on database
							
							.if eax == 0 ;  0 = success
						
  	 							invoke mysql_query,  offset myData ,addr createtable   ; Create a new table
						
      							.if eax == 0 ;  0 = success
							
									invoke EnableMenuItem, hMenu, IDM_CREATE, MF_GRAYED
									invoke EnableMenuItem, hMenu, IDM_QUERY, MF_ENABLED
									invoke EnableMenuItem, hMenu, IDM_INSERT_DATA, MF_ENABLED
									invoke EnableMenuItem, hMenu, IDM_DELETE, MF_ENABLED
							
      							.else 
      							
      								invoke mysql_error,offset myData
      								invoke MessageBox,0,eax,addr mysqlerror,0
      								
      							.endif
							    
      						.else 
      						
      							invoke mysql_error,offset myData
      							invoke MessageBox,0,eax,addr mysqlerror,0
      							
      						.endif
							
						.else      
						   
							invoke mysql_error,offset myData   
							invoke MessageBox,0,eax,addr mysqlerror,0
							
						.endif
						
				.else 
				
					invoke mysql_error,offset myData   
					invoke MessageBox,0,eax,addr mysqlerror,0
					
				.endif
		
		.elseif wParam == IDM_DELETE
		
			invoke mysql_query,  offset myData ,addr dropdb		; Drop (Delete) database
			
			.if eax == 0
			
 				invoke EnableMenuItem, hMenu, IDM_DISCONNECT, MF_ENABLED
				invoke EnableMenuItem, hMenu, IDM_CREATE, MF_ENABLED
				invoke EnableMenuItem, hMenu, IDM_CONNECT, MF_GRAYED
				invoke EnableMenuItem, hMenu, IDM_DELETE, MF_GRAYED
				invoke EnableMenuItem, hMenu, IDM_INSERT_DATA, MF_GRAYED
				invoke EnableMenuItem, hMenu, IDM_QUERY, MF_GRAYED
				
				invoke SendMessage,hList,LVM_DELETEALLITEMS,0,0	
				invoke SendMessage,hList, LVM_DELETECOLUMN,0,addr lvc
				invoke SendMessage,hList, LVM_DELETECOLUMN,0,addr lvc
							
				invoke InsertColumn,hList 			
							
			.else
			
				invoke mysql_error,offset myData
				invoke MessageBox,0,eax,addr mysqlerror,0
				
			.endif
			
           		 
		.elseif wParam == IDM_DISCONNECT	
		
				invoke SendMessage,hStatusBar,SB_SETICON,0,NULL
				invoke SendMessage,hStatusBar,SB_SETTEXT,0, 0
				invoke EnableMenuItem, hMenu, IDM_CONNECT, MF_ENABLED
				invoke EnableMenuItem, hMenu, IDM_DELETE, MF_GRAYED
				invoke EnableMenuItem, hMenu, IDM_INSERT_DATA, MF_GRAYED
				invoke EnableMenuItem, hMenu, IDM_DISCONNECT, MF_GRAYED
				invoke EnableMenuItem, hMenu, IDM_CREATE, MF_GRAYED
				invoke EnableMenuItem, hMenu, IDM_QUERY, MF_GRAYED
				
				invoke SendMessage,hList,LVM_DELETEALLITEMS,0,0	
				invoke SendMessage,hList, LVM_DELETECOLUMN,0,addr lvc
				invoke SendMessage,hList, LVM_DELETECOLUMN,0,addr lvc
							
				invoke InsertColumn,hList 		
			
				invoke mysql_close,offset myData	;Closes a previously opened connection.
				
		.elseif wParam == IDM_ABOUT
		
		       	szText mytext,"MySQL Database Example"
          		szText AboutMsg,"MySQL Database Example",13,10,\
           		"Copyright  Techuser Software 2004"
             	invoke ShellAbout,hWnd,ADDR mytext,ADDR AboutMsg,hIcon			
				
		.elseif wParam == IDM_EXIT

		
				invoke SendMessage,hWnd,WM_SYSCOMMAND,SC_CLOSE,NULL 				

			.endif	
			
	
		
      .elseif uMsg == WM_CLOSE



	.elseif uMsg == WM_SIZE

		invoke Resize,hWnd,uMsg,wParam,lParam	; resize windows



    .elseif uMsg == WM_DESTROY

		
			invoke mysql_close,offset myData	 ;Closes a previously opened connection.

				


          invoke PostQuitMessage,NULL
        return 0  

    .endif

     invoke DefWindowProc,hWnd,uMsg,wParam,lParam

    ret

WndProc endp

;===========================================================================================

TopXY proc wDim:DWORD, sDim:DWORD

    ;=====================================================
    ; This procedure calculates the top X & Y co-ordinates
    ; for the CreateWindowEx call in the WinMain procedure
    ;=====================================================

    shr sDim, 1      ; divide screen dimension by 2
    shr wDim, 1      ; divide window dimension by 2 
    mov eax, wDim    ; copy window dimension into eax
    sub sDim, eax    ; sub half win dimension from half screen dimension

    return sDim

TopXY endp
 
;===========================================================================================

FillDataProc	Proc uses edi

LOCAL row:DWORD
mov row,0


		invoke SendMessage,hList,LVM_DELETEALLITEMS,0,0	
		invoke SendMessage,hList, LVM_DELETECOLUMN,0,addr lvc
		invoke SendMessage,hList, LVM_DELETECOLUMN,0,addr lvc
						
		invoke InsertColumn,hList   
 
		invoke mysql_real_query,  offset myData ,addr mysqlquery,lengthof mysqlquery		; Query database for data
		
		.if eax == 0
	
			invoke mysql_store_result, offset myData	; Get a result set
			mov dword ptr res,eax 

			.if eax != 0

			@@:		
				invoke mysql_fetch_row, dword ptr res		;Retrieves the next row of a result set.
				mov edi,eax
					
				.if eax != 0
				
					mov lvi.imask,LVIF_TEXT+LVIF_PARAM
					push row
					pop lvi.iItem	
					mov lvi.iSubItem,0
					mov eax,[edi]
					mov lvi.pszText, eax 
					push row
					pop lvi.lParam
					invoke SendMessage,hList, LVM_INSERTITEM,0, addr lvi
					
					mov lvi.imask,LVIF_TEXT
					inc lvi.iSubItem
					mov eax,[edi+4]
					mov lvi.pszText,eax
					invoke SendMessage,hList,LVM_SETITEM, 0,addr lvi
					
					jmp @B
					
				.else
					
				.endif	



			.else

			invoke mysql_error,offset myData
			invoke MessageBox,0,eax,addr mysqlerror,0

			.endif
		
		.else
		
      		invoke mysql_error,offset myData
      		invoke MessageBox,0,eax,addr mysqlerror,0
		
		.endif

ret
FillDataProc	Endp

;===========================================================================================

Resize proc hWnd:DWORD, uMsg:UINT, wParam:DWORD, lParam:DWORD



    LOCAL wHgt			:DWORD
    LOCAL Rct			:RECT
	LOCAL hWndRight		:DWORD


	
			invoke GetClientRect,hWnd,ADDR Rct
			mov eax, Rct.right
			mov hWndRight,eax

			mov eax, Rct.bottom
			mov wHgt,eax
			sub wHgt,20  

			invoke MoveWindow,hList,0,0,hWndRight,wHgt,TRUE			

			invoke MoveWindow,hStatusBar,0,0,0,0,TRUE

ret

Resize Endp

;===========================================================================================

InsertColumn proc lvhandle:DWORD   


	mov lvc.imask,LVCF_TEXT+LVCF_WIDTH;+LVCF_IMAGE
	mov lvc.pszText,offset Col1 
	mov lvc.iImage,5
	mov lvc.lx,65
	invoke SendMessage,lvhandle, LVM_INSERTCOLUMN,0,addr lvc

	or lvc.imask,LVCF_FMT
	mov lvc.fmt,LVCFMT_LEFT
	mov lvc.pszText,offset Col2 
	mov lvc.lx,80
	invoke SendMessage,lvhandle, LVM_INSERTCOLUMN, 1 ,addr lvc	


	
	ret		
InsertColumn endp

;===========================================================================================

Do_Status proc hStatusParent:DWORD

    LOCAL sbParts[4] :DWORD

    invoke CreateStatusWindow,WS_CHILD or WS_VISIBLE or SBS_SIZEGRIP,NULL, hStatusParent, 200
    mov hStatusBar, eax
      
    ; =====================================
    ; sbParts is a DWORD array of 4 members
    ; =====================================
    mov [sbParts +  0],   180    ; pixels from left
    mov [sbParts +  4],   330    ; pixels from left
    mov [sbParts +  8],   560    ; pixels from left
    mov [sbParts + 12],    -1    ; last part

    invoke SendMessage,hStatusBar,SB_SETPARTS,4,ADDR sbParts

    ret

Do_Status endp

;===========================================================================================

end start
